=== debian/changelog ===
libcgns (3.1.4.2-1) unstable; urgency=low

  * New upstream release
  * Standards-Version updated to 3.9.4
  * Enable the fortran bindings (Closes: #717850) (LP: #1204846)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 06 Aug 2013 14:31:48 +0200
