=== debian/rules ===
#!/usr/bin/make -f
# Copyright 2008 Sylvestre Ledru <sylvestre.ledru@inria.fr>

include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/patchsys-quilt.mk

CFLAGS+="-I/usr/include/mpi/"

DEB_CMAKE_EXTRA_FLAGS += -DENABLE_64BIT=OFF -DENABLE_HDF5=ON \
 -DENABLE_LEGACY=ON -DENABLE_SCOPING=ON -DENABLE_FORTRAN=ON


DEB_CONFIGURE_NORMAL_ARGS += --enable-shared=all --with-hdf5=/usr \
	--with-szip --enable-lfs --enable-debug

ifeq ($(DEB_BUILD_ARCH),hppa)
  DEB_CONFIGURE_NORMAL_ARGS += --disable-64bit
else
  DEB_CONFIGURE_NORMAL_ARGS += --enable-64bit
endif



install/libcgns-dev::
#	for file in $(DEB_DESTDIR)/usr/lib/* ; do \
#		chrpath -d $$file; \
#	done

get-orig-source:
	uscan --force-download --rename
